package com.gyee.generation.service.function;


import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.RandomUtil;
import cn.hutool.core.util.StrUtil;
import com.gyee.generation.init.CacheContext;
import com.gyee.generation.model.auto.*;
import com.gyee.generation.service.auto.IProBasicCompanyService;
import com.gyee.generation.service.auto.IProBasicRegionService;
import com.gyee.generation.service.auto.IProEconTestingPointService;
import com.gyee.generation.service.initialpoint.IinitialPoint;
import com.gyee.generation.util.ExcelExport;
import com.gyee.generation.util.realtimesource.TaosUtil;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.io.IOException;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Service
public class RfdlService   {


    @Resource
    private TaosUtil taosUtil;



    public void basic(String range, String result, List<PointDataTaos> pointDataTaosLs) {


     if(ObjectUtil.isNotEmpty(range) && StrUtil.isNotEmpty(range))
        {
            String[] ranges= range.split(",");
            List<String> ls = Arrays.asList(ranges);

            if(!ls.isEmpty())
            {
                if(ls.contains("WT"))
                {
                    List<ProBasicEquipment> wtls= CacheContext.wtls;
                    for(ProBasicEquipment wt:wtls)
                    {
                        if(CacheContext.eqpointmap.containsKey(wt.getNemCode()))
                        {
                            Map<String, ProBasicEquipmentPoint> map=CacheContext.eqpointmap.get(wt.getNemCode());

                            equipmentCal(result, pointDataTaosLs, map);
                        }
                    }
                }else   if(ls.contains("LN"))
                {
                    List<ProBasicLine> lnls= CacheContext.lnls;
                    for(ProBasicLine ln:lnls)
                    {

                        if(CacheContext.linepointmap.containsKey(ln.getNemCode()))
                        {
                            Map<String, ProBasicPowerstationPoint> map=CacheContext.linepointmap.get(ln.getNemCode());

                            powerstationCal(result, pointDataTaosLs, map);
                        }


                    }
                }else   if(ls.contains("PJ"))
                {
                    List<ProBasicProject> pjls= CacheContext.pjls;
                    for(ProBasicProject pj:pjls)
                    {


                        if(CacheContext.propointmap.containsKey(pj.getNemCode()))
                        {
                            Map<String, ProBasicPowerstationPoint> map=CacheContext.propointmap.get(pj.getNemCode());

                            powerstationCal(result, pointDataTaosLs, map);
                        }


                    }
                }
                else   if(ls.contains("WP"))
                {
                    List<ProBasicPowerstation> wpls= CacheContext.wpls;
                    for(ProBasicPowerstation wp:wpls)
                    {


                        if(CacheContext.wppointmap.containsKey(wp.getNemCode()))
                        {
                            Map<String, ProBasicPowerstationPoint> map=CacheContext.wppointmap.get(wp.getNemCode());

                            powerstationCal(result, pointDataTaosLs, map);
                        }


                    }
                }else   if(ls.contains("CP"))
                {
                    List<ProBasicCompany> cpls= CacheContext.cpls;
                    for(ProBasicCompany cp:cpls)
                    {


                        if(CacheContext.companypointmap.containsKey(cp.getNemCode()))
                        {
                            Map<String, ProBasicPowerstationPoint> map=CacheContext.companypointmap.get(cp.getNemCode());

                            powerstationCal(result, pointDataTaosLs, map);
                        }


                    }
                }else   if(ls.contains("RG"))
                {
                    List<ProBasicRegion> rgls= CacheContext.rgls;
                    for(ProBasicRegion rg:rgls)
                    {


                        if(CacheContext.regionpointmap.containsKey(rg.getNemCode()))
                        {
                            Map<String, ProBasicPowerstationPoint> map=CacheContext.regionpointmap.get(rg.getNemCode());

                            powerstationCal(result, pointDataTaosLs, map);
                        }


                    }
                }else   if(ls.contains("EG"))
                {
                    List<ProBasicEnergyGroup> egls= CacheContext.egls;
                    for(ProBasicEnergyGroup eg:egls)
                    {

                        if(CacheContext.grouppointmap.containsKey(eg.getNemCode()))
                        {
                            Map<String, ProBasicPowerstationPoint> map=CacheContext.grouppointmap.get(eg.getNemCode());

                            powerstationCal(result, pointDataTaosLs, map);
                        }


                    }
                }



                if(!pointDataTaosLs.isEmpty())
                {
                    taosUtil.sendSinglePoint(pointDataTaosLs);
                }

            }

        }
    }

    private  void powerstationCal(String result, List<PointDataTaos> pointDataTaosLs, Map<String, ProBasicPowerstationPoint> map) {
        if(map.containsKey(result) )
        {
            ProBasicPowerstationPoint point= map.get(result);

            PointDataTaos pt=new PointDataTaos();
            pt.setId(point.getNemCode());
            pt.setTs(new Timestamp(System.currentTimeMillis()));
             pt.setVal(Double.valueOf(RandomUtil.randomDouble(0,10)));
            pt.setMetric(1);
            pointDataTaosLs.add(pt);
            if(pointDataTaosLs.size()==100)
            {
                taosUtil.sendSinglePoint(pointDataTaosLs);
                pointDataTaosLs.clear();
            }
        }
    }

    private  void equipmentCal(String result, List<PointDataTaos> pointDataTaosLs, Map<String, ProBasicEquipmentPoint> map) {


        if(map.containsKey(result) )
        {

            ProBasicEquipmentPoint point= map.get(result);

            PointDataTaos pt=new PointDataTaos();
            pt.setId(point.getNemCode());
            pt.setTs(new Timestamp(System.currentTimeMillis()));
            pt.setVal(Double.valueOf(RandomUtil.randomDouble(0,10)));
            pt.setMetric(1);
            pointDataTaosLs.add(pt);

            if(pointDataTaosLs.size()==100)
            {
                taosUtil.sendSinglePoint(pointDataTaosLs);
                pointDataTaosLs.clear();
            }
        }
    }


}
