package com.gyee.generation;



import cn.hutool.Hutool;
import cn.hutool.core.util.RandomUtil;
import com.gyee.generation.init.CacheContext;
import com.gyee.generation.model.auto.*;
import com.gyee.generation.service.initialpoint.TaosInitalPonitService;
import com.gyee.generation.util.SpringUtils;
import com.gyee.generation.util.realtimesource.IRealDataUtil;
import com.gyee.generation.util.realtimesource.timeseries.PointData;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;

import java.sql.Timestamp;
import java.util.*;

@SpringBootApplication
public class TaosTest
{
    public static void main(String[] args) throws Exception {
        SpringApplication.run(TaosTest.class, args);

        TaosInitalPonitService taosInitalPonitService= SpringUtils.getBean("taosInitalPonitService");
        IRealDataUtil taosUtil= SpringUtils.getBean("taosUtil");



                List<PointDataTaos>  taosList=new ArrayList();

        for(ProBasicEquipment wt:CacheContext.wtls)
        {
            if(CacheContext.eqpointmap.containsKey(wt.getNemCode()))
            {
                Map<String, ProBasicEquipmentPoint> map=CacheContext.eqpointmap.get(wt.getNemCode());

                for (Map.Entry <String, ProBasicEquipmentPoint> entry : map.entrySet()) {
                    System.out.println("Key = " + entry.getKey() + ", Value = " + entry.getValue());

                    PointDataTaos taos1=new PointDataTaos();
                    taos1.setId(entry.getValue().getNemCode());
                    taos1.setTs(new Timestamp(new Date().getTime()));
                    taos1.setVal(RandomUtil.randomDouble(0,10));
                    taos1.setMetric(1);
                    taosList.add(taos1);

                    if(taosList.size()==100)
                    {
                        taosUtil.sendSinglePoint(taosList);

                        taosList.clear();
                    }
                }

            }
        }
        if(!taosList.isEmpty())
        {
            taosUtil.sendSinglePoint(taosList);
        }

        taosList=new ArrayList();

        for(ProBasicLine ln:CacheContext.lnls)
        {
            if(CacheContext.linepointmap.containsKey(ln.getNemCode()))
            {
                Map<String, ProBasicPowerstationPoint> map=CacheContext.linepointmap.get(ln.getNemCode());

                for (Map.Entry <String, ProBasicPowerstationPoint> entry : map.entrySet()) {
                    System.out.println("Key = " + entry.getKey() + ", Value = " + entry.getValue());

                    PointDataTaos taos1=new PointDataTaos();
                    taos1.setId(entry.getValue().getNemCode());
                    taos1.setTs(new Timestamp(new Date().getTime()));
                    taos1.setVal(RandomUtil.randomDouble(0,10));
                    taos1.setMetric(1);
                    taosList.add(taos1);

                    if(taosList.size()==100)
                    {
                        taosUtil.sendSinglePoint(taosList);

                        taosList.clear();
                    }
                }

            }
        }
        if(!taosList.isEmpty())
        {
            taosUtil.sendSinglePoint(taosList);
        }


        taosList=new ArrayList();

        for(ProBasicProject pj:CacheContext.pjls)
        {
            if(CacheContext.propointmap.containsKey(pj.getNemCode()))
            {
                Map<String, ProBasicPowerstationPoint> map=CacheContext.propointmap.get(pj.getNemCode());

                for (Map.Entry <String, ProBasicPowerstationPoint> entry : map.entrySet()) {
                    System.out.println("Key = " + entry.getKey() + ", Value = " + entry.getValue());

                    PointDataTaos taos1=new PointDataTaos();
                    taos1.setId(entry.getValue().getNemCode());
                    taos1.setTs(new Timestamp(new Date().getTime()));
                    taos1.setVal(RandomUtil.randomDouble(0,10));
                    taos1.setMetric(1);
                    taosList.add(taos1);

                    if(taosList.size()==100)
                    {
                        taosUtil.sendSinglePoint(taosList);

                        taosList.clear();
                    }
                }

            }
        }
        if(!taosList.isEmpty())
        {
            taosUtil.sendSinglePoint(taosList);
        }

        taosList=new ArrayList();

        for(ProBasicPowerstation wp:CacheContext.wpls)
        {
            if(CacheContext.wppointmap.containsKey(wp.getNemCode()))
            {
                Map<String, ProBasicPowerstationPoint> map=CacheContext.wppointmap.get(wp.getNemCode());

                for (Map.Entry <String, ProBasicPowerstationPoint> entry : map.entrySet()) {
                    System.out.println("Key = " + entry.getKey() + ", Value = " + entry.getValue());

                    PointDataTaos taos1=new PointDataTaos();
                    taos1.setId(entry.getValue().getNemCode());
                    taos1.setTs(new Timestamp(new Date().getTime()));
                    taos1.setVal(RandomUtil.randomDouble(0,10));
                    taos1.setMetric(1);
                    taosList.add(taos1);

                    if(taosList.size()==100)
                    {
                        taosUtil.sendSinglePoint(taosList);

                        taosList.clear();
                    }
                }

            }
        }
        if(!taosList.isEmpty())
        {
            taosUtil.sendSinglePoint(taosList);
        }
//        taosInitalPonitService.initalTaosPointTable();
//
//        alarmCtService.createSuperTable();
//        alarmCtService.initalCtAlarm();
//
//

//
//        String[] points={"SXJ_KGDL_FLFD_BHB_F_P1_L1_0001_AI0061",
//                "SXJ_KGDL_FLFD_BHB_F_P1_L1_0001_AI0062",
//                "SXJ_KGDL_FLFD_BHB_F_P1_L1_0001_AI0063",
//                "SXJ_KGDL_FLFD_BHB_F_P1_L1_0001_AI0064"
//                };
//        List<PointData> ls= taosUtil.getRealData(points);
//
//
//
//
//        List<PointDataTaos>  taosList=new ArrayList();
//        PointDataTaos taos1=new PointDataTaos();
//        taos1.setId("SXJ_KGDL_FLFD_BHB_F_P1_L1_0001_AI0064");
//        taos1.setTs(new Timestamp(new Date().getTime()));
//        taos1.setVal(12.6);
//        taos1.setMetric(1);
//        taosList.add(taos1);
//        PointDataTaos taos2=new PointDataTaos();
//        taos2.setId("SXJ_KGDL_FLFD_BHB_F_P1_L1_0001_AI0064");
//        taos2.setTs(new Timestamp(new Date().getTime()+3000l));
//        taos2.setVal(18.6);
//        taos2.setMetric(1);
//        taosList.add(taos2);
//
//        taosUtil.sendSinglePoint(taosList);
//        List<PointData> ls=taosUtil.getHistoryDatasSnap( "SXJ_KGDL_FLFD_BHB_F_P1_L1_0001_AI0064",1717430400l,new Date().getTime()/1000,null,600l);
//

//        List<PointData> ls=taosUtil.getHistoryDatasRaw( "SXJ_KGDL_FLFD_BHB_F_P1_L1_0001_AI0064",1717430400l,1717468230l);
//
//        List<PointData> ls=taosUtil.getHistStat( "SXJ_KGDL_FLFD_BHB_F_P1_L1_0001_AI0064",1717430400l,new Date().getTime()/1000,null,600l,0);
//        for(int i=0;i<ls.size();i++)
//        {
//
//            PointData value= ls.get(i);
//            System.out.println(value.getPointValueInDouble());
//        }
//


        System.out.println("完成！");


    }
}
